require 'spec_helper'

describe CredibleEmail do
  describe 'valid?' do
    context 'given a valid email address' do
      [
        'daniel@honestempire.com',
        'daniel.morris@honestempire.com',
        'daniel@subdomain.honestempire.com',
        'daniel@127.0.0.1',
        'daniel@[127.0.0.1]',
        'daniel+filter@honestempire.com',
        '"daniel morris"@honestempire.com',
        '466378@honestempire.com',
        'daniel@honest-empire.com',
        'daniel_morris.period@honest-empire.com',
        'daniel@honestempire.museum',
        'daniel@correcthorsebatterystaplecorrecthorsebatterystaple.com',
        'd@h.e',
        'daniel."honest empire"@honestempire.co.uk',
        'hello@xn--ls8h.com'
      ].each do |email|
        it "#{email} should be valid" do
          expect(Person.new(email: email)).to be_valid
        end
      end
    end

    context 'given an invalid email address' do
      [
        'daniel',
        'daniel morris',
        '@honestempire',
        '@honestempire.com',
        'daniel@honestempire .com',
        'daniel@honestempire'
      ].each do |invalid_email|
        it "#{invalid_email} should not be valid" do
          expect(Person.new(email: invalid_email)).to_not be_valid
        end
      end
    end
  end
end
